﻿//-----------------------------------------------------------------------
// <copyright company="CoApp Project">
//     Copyright (c) 2010 Eric Schultz. All rights reserved.
// </copyright>
//-----------------------------------------------------------------------

namespace CoApp.mkPackage
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.IO;
    using Mono.Security.Authenticode;
    abstract class SigVerifier
    {
       
        

        protected SigVerifier()
        {
        }

        
        /// <summary>
        /// 
        /// </summary>
        /// <param name="nonAssemblies">a list of PE files that aren't in an assembly</param>
        /// <returns></returns>
        internal bool VerifyNonAssemblies(IEnumerable<String> nonAssemblies)
        {
             bool ret = true;
            
             foreach (String fileName in nonAssemblies)
             {
                 try
                 {
                     var authenticodeFileHandler = new AuthenticodeDeformatter(fileName);

                     if (authenticodeFileHandler.Certificates.Count < 1)
                     {
                         ret = false;
                         Console.WriteLine(fileName + " is not properly signed.");
                     }
                 }
                 catch (IOException e)
                 {
                    ret = false;
                    Console.WriteLine(e.Message);
                 }
             }

             return ret;
        }


        internal abstract bool VerifyAssemblies(IEnumerable<String> assemblies);

    }
}
